﻿##### Распакуйте собранный TAR и положите туда этот файл + запустите на MacOS #####

################# НАСТРОЙКА DMG ИНТЕРФЕЙСА #################
# Картинка для фона лежит в корне проекта [background.png] #

#Левый верхний угол где откроется DMG
WINDOW_LEFT=400
WINDOW_TOP=150
#Координаты нижнего правого угла. Тут значения составленные из левого верхнего угла (2 переменные выше) и самого размера(ширина и высота)!
#Притом для высоты 20 пикселей резервируем дополнительно, они "уйдут" на строку состояния (с названием с "светофором")
WINDOW_RIGHT=1200
WINDOW_BOTTOM=670
#Где находится Apps папка, куда предлагается перетащить программу
APPS_X=535
APPS_Y=345
#Где находится сама программа
BUNDLE_X=253
BUNDLE_Y=345
#Имя собранной .app папки
APP_BUNDLE_NAME="LuxinfineLauncherLoader.app"

############################################################


TMP_DIR="./TEMP"
APP_VERSION=`/usr/libexec/PlistBuddy -c "Print :CFBundleShortVersionString" "${APP_BUNDLE_NAME}/Contents/Info.plist"`
APP_BUILD_VERSION=`/usr/libexec/PlistBuddy -c "Print :CFBundleVersion" "${APP_BUNDLE_NAME}/Contents/Info.plist"`
DMG_NAME="LauncherLoader.dmg"
DMG_NAME_TMP="LauncherLoader_TEMP.dmg"
VOL_NAME=${APP_BUNDLE_NAME%.*}

mkdir "${TMP_DIR}"
mkdir "${TMP_DIR}/.background/"

cp "background.png" "${TMP_DIR}/.background/background.png"
cp "MacIcon.icns" "${TMP_DIR}/.VolumeIcon.icns"
cp -R "${APP_BUNDLE_NAME}" "${TMP_DIR}/"

hdiutil create -ov -srcfolder ${TMP_DIR} -format UDRW -volname "${VOL_NAME}" "${DMG_NAME_TMP}"

device=$(hdiutil attach -readwrite -noverify -noautoopen ${DMG_NAME_TMP} | egrep '^/dev/' | sed 1q | awk '{print $1}')

ICON_FOLDER="/Volumes/${VOL_NAME}"

echo "Applying apple script..."
APPLESCRIPT="
tell application \"Finder\"
tell disk \"${VOL_NAME}\"
open
-- Setting view options
set current view of container window to icon view
set toolbar visible of container window to false
set statusbar visible of container window to false
set the bounds of container window to {${WINDOW_LEFT}, ${WINDOW_TOP}, ${WINDOW_RIGHT}, ${WINDOW_BOTTOM}}
set theViewOptions to the icon view options of container window
set arrangement of theViewOptions to not arranged
set icon size of theViewOptions to 72
-- Settings background
set background picture of theViewOptions to file \".background:background.png\"
-- Adding symlink to /Applications
make new alias file at container window to POSIX file \"/Applications\" with properties {name:\"Applications\"}
-- Reopening
close
open
-- Rearranging
set the position of item \"Applications\" to {${APPS_X}, ${APPS_Y}}
set the position of item \"${APP_BUNDLE_NAME}\" to {${BUNDLE_X}, ${BUNDLE_Y}}
-- Updating and sleeping for 5 secs
update without registering applications
delay 5
end tell
end tell
"

echo "$APPLESCRIPT" | osascript
echo "Script applied!"

#После apple script куда-то исчезает файл, ещё раз копируем -_-
cp "MacIcon.icns" "${ICON_FOLDER}/.VolumeIcon.icns"

SetFile -c icnC "${ICON_FOLDER}/.VolumeIcon.icns"
SetFile -a C "${ICON_FOLDER}"

chmod -Rf go-w /Volumes/"${VOL_NAME}"

sync
sync
hdiutil detach ${device}

hdiutil convert "${DMG_NAME_TMP}" -format UDZO -imagekey zlib-level=9 -o "${DMG_NAME}"

#cleanup
rm "${DMG_NAME_TMP}"
rm -r "${TMP_DIR}"